<script lang="ts">
import { AosAnimationsMixin, IsMobileMixin, LivePreviewMixin } from '~/mixins';
import ArticleHero from '~/components/the-source/hero.vue';
import ShareButtons from '~/components/common/share-buttons.vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { generateLayoutMeta, getPageMetadata } from '~/common/meta';
import { CardList } from '~/components/common/index';
import { ContentfulLivePreview } from '@contentful/live-preview';

export default {
  nuxtI18n: false,
  components: {
    CardList,
    ShareButtons,
    ArticleHero,
  },
  mixins: [LivePreviewMixin, AosAnimationsMixin, IsMobileMixin],
  data() {
    return {
      article: null,
      ctfPage: null,
      locale: '',
    };
  },
  fetchOnServer: false,
  async fetch() {
    const id = this.$route.query.id;
    const locale = this.$route.query.locale;
    const config = {
      accessToken: this.$config.preview,
      space: this.$config.space,
      host: 'preview.contentful.com',
    };
    try {
      const page = await this.$articleService.getPreviewContent(
        id,
        locale,
        config,
      );
      this.article = page.fields;
      this.ctfPage = page;
      this.locale = locale;
    } catch (e) {
      throw new Error(e);
    }
  },
  head(): MetaInfo {
    const getMetaData = {
      ...(this.article || {}),
      noIndex: true,
    };
    const metadata = getPageMetadata(getMetaData, this.$route.path);
    const layoutMeta = generateLayoutMeta(this.$route.path, this.$i18n.locale);
    return {
      ...metadata,
      link: [...metadata.link, ...layoutMeta.link],
      htmlAttrs: { ...layoutMeta.htmlAttrs },
    } as MetaInfo;
  },
  mounted() {
    if (this.isPreview && this.ctfPage) {
      const unsubscribeFn = ContentfulLivePreview.subscribe({
        data: this.ctfPage,
        callback: (updatedData) => (this.article = updatedData.fields),
      });
      this.livePreviewSubscriptions.push(unsubscribeFn);
    }
  },
};
</script>

<template>
  <div v-if="article" class="article">
    <section>
      <ArticleHero :article="article" />
      <SlpContainer v-if="isMobile">
        <CardList :list="article.keyTakeaways" />
      </SlpContainer>
      <!-- Article Body Start -->
      <SlpContainer class="slp-mb-128">
        <SlpRow>
          <SlpColumn :cols="8">
            <div
              class="article__body"
              v-html="$md.render(article.articleBody)"
            />
          </SlpColumn>
          <SlpColumn :cols="4">
            <div class="article__side">
              <ShareButtons />
              <CardList v-if="!isMobile" :list="article.keyTakeaways" />
            </div>
          </SlpColumn>
        </SlpRow>
      </SlpContainer>
      <!-- Article Body End -->
    </section>
  </div>
</template>

<style scoped lang="scss">
$heading-sizes: (
  'h1': $text-heading-1,
  'h2': $text-heading-2,
  'h3': $text-heading-3,
  'h4': $text-heading-4,
  'h5': $text-heading-5,
);

$line-heights: (
  'h1': $line-height-heading-1,
  'h2': $line-height-heading-2,
  'h3': $line-height-heading-3,
  'h4': $line-height-heading-4,
  'h5': $line-height-heading-5,
);

.article {
  &__body {
    &:deep {
      p {
        padding-bottom: $spacing-16;

        &:last-of-type {
          padding-bottom: $spacing-32;
        }
      }

      @each $heading, $size in $heading-sizes {
        p + #{$heading} {
          padding-top: $spacing-16;
        }

        #{$heading} {
          padding-bottom: $spacing-32;
          font-weight: $font-weight-bold;
          font-size: $size;
          line-height: map-get($line-heights, $heading);
        }

        // Add no-anchor class to heading for removing anchor tag
        .no-anchor {
          .header-anchor {
            display: none;
          }
        }
      }

      // Articles Card using Markdown
      blockquote {
        background-color: $color-surface-800;
        padding: $spacing-32;
        border-radius: 4px;

        p:last-of-type {
          padding-bottom: 0;
        }

        img {
          width: 100%;
          max-height: 371px;
        }

        @each $heading, $size in $heading-sizes {
          #{$heading} {
            padding-bottom: $spacing-16;
          }
        }
      }

      img {
        width: 100%;
      }

      // Articles Button using markdown
      .button {
        margin-top: $spacing-16;
        align-items: center;
        border-radius: 4px;
        display: inline-flex;
        font-size: $text-button-1;
        font-weight: $font-weight-bold;
        line-height: $line-height-button-1;
        min-width: 68px;
        padding: 11px $spacing-16;
        text-align: center;
        transition: background-color 0.3s cubic-bezier(0.7, 0, 0.3, 1);
        vertical-align: middle;
        background-color: $color-primary-200;
        border: 1px solid $color-primary-200;
        color: $color-primary-300;

        &:hover {
          background-color: white;
          color: $color-primary-200;
        }
      }
    }
  }

  &__side {
    position: sticky;
    top: 100px;
    padding: 0 32px;
    margin-top: -248px;

    @media (max-width: $breakpoint-md) {
      padding: 0;
      margin-top: $spacing-16;
    }
  }
}
</style>
